#!/bin/bash

# Checker Tema2 - Competitie, PC 2014

tema="tema2"

if [ ! -e $tema ]; then
	echo "Error: File '$tema' is not in the same directory as this script"
	exit 1
fi

if [ ! -x $tema ]; then
	echo "Error: File '$tema' does not have executable right"
	echo "One can run: 'sudo chmod +x $tema'"
	exit 1
fi 

if [ $# -eq 0 ]; then
	sum=0
	echo ""
	echo "=== Running checker on all tests ==="
	echo ""
	for i in $(seq 1 10); do
		./$tema < input/test$i.in > out
		diff -wB out output/test$i.ref > /dev/null
		if [ $? -eq 0 ]; then
			echo "Test $i .......................... passed"
			sum=$(($sum + 9))
		else
			echo "Test $i .......................... failed"
		fi
	done
	rm out
	echo ""
	echo "TOTAL: $sum/90 puncte"
elif [ $# -eq 1 ]; then
		if (( $1 < 1 || $1 > 10)); then
				echo "Invalid test number: should be in [1, 10]"
				exit 1
		else
				./$tema < input/test$1.in > out
				diff -wB out output/test$1.ref > /dev/null
				if [ $? -eq 0 ]; then
					echo "Test $i .......................... passed"
				else
					echo "Test $i .......................... failed"
				fi
				rm out
		fi
else
	echo "Incorrect number of parameters:"
	echo "Run: '$0' for checking all tests"
	echo "or   '$0 test_number' for checking test_number test"
fi


